Function ReadInParameters(datei:TStream,net:Byte Var,wid:Short Var, hei:Short Var)
	Local lin$,v$,wert$
	Repeat
		lin=ReadLine(datei)
		v=Lower(Left(lin,Instr(lin,"=")-1))
		wert=Lower(Mid(lin,Instr(lin,"=")+1,-1))
		Select v
		Case "driver"
			If wert="directx" Then
				net=0
			ElseIf wert="opengl" Then
				net=1
			EndIf
		Case "width"
			wid=Int(wert)
		Case "height"
			hei=Int(wert)
		Default
			Print "Warning: unknown variable"
		EndSelect
	Until Eof(datei)
EndFunction

Function selection()
	Local r%,g%,b%
	GetClsColor(r,g,b)
	SetClsColor 0,0,0
	For Local alpha#=0 To 1 Step 0.01
		Cls
		SetAlpha alpha
		DrawImage hgimage,0,0
		Flip 0
		WaitTimer timer
	Next
	Delay 750
	SetAlpha 1
	Local spieler$
	
	Repeat
		Cls
		SetColor 255,255,255
		DrawImage hgimage,0,0
		DrawRect 10,10,200,33
		SetColor 0,0,0
		DrawText "Spielerzahl: ",12,12
		DrawText "(max = 5)",12,27

		DrawNumField(spieler,130,15,60)
		If KeyHit(KEY_ESCAPE) Or AppTerminate() Then End
		If KeyHit(KEY_RETURN) And Int(spieler)>=1 And Int(spieler)<=5 Then Exit
		Flip 0
		WaitTimer timer
	Forever
	Local name$
	For Local i%=1 To Int(spieler)
		name=""
		Repeat
			Cls
			SetColor 255,255,255
			DrawImage hgimage,0,0
			DrawRect 10,10,270,33
			SetColor 0,0,0
			DrawText "Spieler("+i+") Name: ",12,17
	
			DrawTextField(name,150,15,120,13)
			If KeyHit(KEY_ESCAPE) Or AppTerminate() Then End
			If KeyHit(KEY_RETURN) And Len(name)>=1 Then Exit
	
	
			Flip 0
			WaitTimer timer		
		Forever
		current_player=TPlayer.Create(name)
		playerlist.AddLast(current_player)
	Next
	SetColor 255,255,255
	For Local alpha#=1 To 0 Step -0.05
		Cls
		SetAlpha alpha
		DrawImage hgimage,0,0
		Flip 0
		WaitTimer timer
	Next
	Delay 150
	SetAlpha 1
	FlushKeys
	SetClsColor r,g,b
EndFunction

Function InitTanks(typ:Byte=0)
	For Local a:TPlayer=EachIn playerlist
		a.tank.init(typ)
	Next
EndFunction

Function Shop()
	Local r%,g%,b%
	GetClsColor(r,g,b)
	SetClsColor 0,0,0
	SetColor 255,255,255
	For Local alpha#=0 To 1 Step 0.05
		Cls
		SetAlpha alpha
		DrawImage hgimage,0,0
		Flip 0
		WaitTimer timer
	Next
	Delay 150
	SetAlpha 1
	For Local x%=10 To 400 Step 10
		Cls
		DrawImage hgimage,0,0
		DrawRect 10,10,x,1
		Flip 0
		WaitTimer timer
	Next
	For Local y%=1 To 400 Step 20
		Cls
		DrawImage hgimage,0,0
		DrawRect 10,10,400,y
		Flip 0
		WaitTimer timer
	Next	
	For Local a:TPlayer=EachIn playerlist
		Repeat
			Cls
			SetColor 255,255,255
			DrawImage hgimage,0,0
			DrawRect 10,10,400,400
			SetColor 0,0,0
			If KeyHit(KEY_ESCAPE) Or AppTerminate() Then End
			DrawText "Spieler: "+a.name,20,20
			DrawText "Geld:  $ "+a.money,20,35
			DrawText "$ "+(9*(a.tank.energy+1)),300,74
			DrawText "$ "+(8*(6-a.tank.engine+1)),300,104
			DrawText "$ "+(8*(TWeapon(a.tank.weaponlist.First()).power-TWeapon(a.tank.weaponlist.First()).startpower+2)),300,134
			DrawText "$ "+(6*(a.tank.hillmove+1)),300,164
			If DrawButton("Schild upgraden",20,70,280) And a.money>=(9*(a.tank.energy+1)) Then a.tank.energy:+1;a.money:-(9*(a.tank.energy))
			If DrawButton("Motor upgraden",20,100,280) And a.money>=(8*(6-a.tank.engine+1)) Then a.tank.engine:-1;a.money:-(8*(6-a.tank.engine))
			If DrawButton("Waffe upgraden",20,130,280) And a.money>=(7*(TWeapon(a.tank.weaponlist.First()).power-TWeapon(a.tank.weaponlist.First()).startpower+2)) Then a.money:-(7*(TWeapon(a.tank.weaponlist.First()).power-TWeapon(a.tank.weaponlist.First()).startpower+2));TWeapon(a.tank.weaponlist.First()).power:+2
			If DrawButton("Steigung upgraden",20,160,280) And a.money>=(6*(a.tank.hillmove+1)) Then a.tank.hillmove:+1;a.money:-(6*(a.tank.hillmove))
			If DrawButton("Ok",20,360,50) Then Exit
			Flip 0
			WaitTimer timer
		Forever
	Next
	SetClsColor r,g,b
EndFunction

Function DrawButton:Byte(txt$,x:Short,y:Short,w:Short)
	Local ret:Byte=0
	If MouseIn(x,y,w,20) Then
		SetColor 100,130,255
		If MouseHit(1) Then ret=1
	Else
		SetColor 70,110,200
	EndIf
	DrawRect x,y,w,20
	SetColor 255,180,0
	DrawText txt,x+2,y+5
	Return ret
EndFunction

Function MouseIn:Byte(x:Short,y:Short,w:Short,h:Short)
	Return (MouseX()>=x) And (MouseY()>=y) And (MouseX()<=x+w) And (MouseY()<=y+h)
EndFunction


Function DrawNumField(txt$ Var,x:Short,y:Short,w:Short,maxnum%=0)
	SetColor 0,0,0
	DrawRect x,y,w,20
	SetColor 255,255,255
	DrawRect x+1,y+1,w-2,18
	SetColor 0,0,0
	DrawText txt,x+2,y+4
	Local b:Byte=GetChar()
	If (b>=48 And b<=57) And (maxnum=0 Or Int(txt+Chr(b))<=maxnum) Then
		txt:+Chr(b)
	ElseIf b=8 And Len(txt)>=1 Then
		txt=Left(txt,Len(txt)-1)
	EndIf
EndFunction

Function DrawTextField(txt$ Var,x:Short,y:Short,w:Short,maxchar:Short=0)
	SetColor 0,0,0
	DrawRect x,y,w,20
	SetColor 255,255,255
	DrawRect x+1,y+1,w-2,18
	SetColor 0,0,0
	DrawText txt,x+2,y+4
	Local b:Byte=GetChar()
	If (b>=65 And b<=90) Or (b>=97 And b<=122) And (maxchar=0 Or maxchar>=Len(txt)+1) Then
		txt:+Upper(Chr(b))
	ElseIf b=8 And Len(txt)>=1 Then
		txt=Left(txt,Len(txt)-1)
	EndIf
EndFunction

Function LoadHGImage()
	Local a:TPixmap=LoadPixmapJPeg("tanks_hg.jpg")
	hgimage=LoadImage(a)
EndFunction

Function HasOneWon:Byte(playerlist:TList) 'Liefert 1 wenn nur noch 1 Tank im Spiel ist, 2 wenn es ein unentschieden gibt und 0 wenn noch gengend da sind
	Local player_amount:Byte=0
	For Local pl:TPlayer=EachIn playerlist
		If pl.tank.maxpower>=1 Then player_amount:+1 
	Next
	Return (player_amount=0)*2 Or (player_amount=1)*1
EndFunction

Const TERRAIN1_COLOR%=$DEDEEE,TERRAIN2_COLOR%=$10BA00,TERRAIN3_COLOR%=$DDEF12


Function RepositionTanks()
	Local b%
	For Local a:TPlayer=EachIn playerlist
		If a.tank.y<base[a.tank.x] Then
			b=(base[a.tank.x]-a.tank.y)
			For Local y%=a.tank.y To base[a.tank.x] Step 4
				Cls
				a.tank.y:+4
				DrawEverything()
				Flip 0
				WaitTimer timer
			Next
			a.tank.y=base[a.tank.x]
			a.tank.maxpower:-b
		EndIf
	Next
EndFunction

Function CreateTerrain(typ:Byte)
	'typ=1 ... Schnee-Level mit hohen Bergen
	'typ=2 ... Grn-Level mit mittleren - niedrigen Hhenschwankungen
	'typ=3 ... Sand-Level mit niedrigen Hhenschwankungen
	Local height#,winkel%
	Select typ
	Case 1
		base_color=TERRAIN1_COLOR
		height=config_height/2+Rand(10,20)
		For Local x:Short=0 To config_width-1
			If Rand(0,20)=10 Then
				If height<=70 Then
					winkel=Rand(0,179)
				ElseIf height>=config_height-110 Then
					winkel=Rand(180,359)
				Else
					winkel=Rand(359)
				EndIf
			Else
				If height<=70 Then
					winkel=Rand(0,179)
				ElseIf height>=config_height-110 Then
					winkel=Rand(180,359)
				Else
					If winkel>=200 And winkel<=250 Then
						winkel:-2
					ElseIf winkel>=290 And winkel<=340 Then
						winkel:+2
					ElseIf winkel>=20 And winkel<=70 Then
						winkel:-2
					ElseIf winkel>=70 And winkel<=160 Then
						winkel:+2
					EndIf
				EndIf			
			EndIf
			base[x]=height
			Rem
			If height<=30 Then
				height=height+Sin(Rand(180,359))*5.8
			ElseIf height>=config_height-70 Then 'Hier -30-40 weil es eine 40-Pixel-Leiste geben soll
				height=height+Sin(Rand(0,179))*5.8
			Else
				height=height+Sin(Rand(359))*5.8
			EndIf
			EndRem
			height:+Sin(winkel)*4.2
		Next
	Case 2
		base_color=TERRAIN2_COLOR
		height=config_height/2+Rand(10,20)
		For Local x:Short=0 To config_width-1
			If Rand(0,20)=10 Then
				If height<=70 Then
					winkel=Rand(0,179)
				ElseIf height>=config_height-110 Then
					winkel=Rand(180,359)
				Else
					winkel=Rand(359)
				EndIf
			Else
				If height<=70 Then
					winkel=Rand(0,179)
				ElseIf height>=config_height-110 Then
					winkel=Rand(180,359)
				Else
					If winkel>=200 And winkel<=250 Then
						winkel:-2
					ElseIf winkel>=290 And winkel<=340 Then
						winkel:+2
					ElseIf winkel>=20 And winkel<=70 Then
						winkel:-2
					ElseIf winkel>=70 And winkel<=160 Then
						winkel:+2
					EndIf
				EndIf
			EndIf
			base[x]=height
			height:+Sin(winkel)*2
		Next
	Case 3
		base_color=TERRAIN3_COLOR
		height=config_height/2+Rand(10,20)
		For Local x:Short=0 To config_width-1
			If Rand(0,20)=10 Then
				If height<=70 Then
					winkel=Rand(0,179)
				ElseIf height>=config_height-110 Then
					winkel=Rand(180,359)
				Else
					winkel=Rand(359)
				EndIf
			Else
				If height<=70 Then
					winkel=Rand(0,179)
				ElseIf height>=config_height-110 Then
					winkel=Rand(180,359)
				Else
					If winkel>=200 And winkel<=250 Then
						winkel:-2
					ElseIf winkel>=290 And winkel<=340 Then
						winkel:+2
					ElseIf winkel>=20 And winkel<=70 Then
						winkel:-2
					ElseIf winkel>=70 And winkel<=160 Then
						winkel:+2
					EndIf
				EndIf			
			EndIf

			base[x]=height
			height:+Sin(winkel)*0.5
		Next
	EndSelect
	
EndFunction

Function DrawTerrain()
	Local i:Byte=0
	For Local x:Short=0 To config_width-1
		i=1-i
		If i=0 Then
			Select base_color
			Case TERRAIN1_COLOR
				SetColor 212,212,238
			Case TERRAIN2_COLOR
				SetColor 16,186,0
			Case TERRAIN3_COLOR
				SetColor 231,229,18
			EndSelect
		Else
			Select base_color
			Case TERRAIN1_COLOR
				SetColor 192,192,238
			Case TERRAIN2_COLOR
				SetColor 0,166,0
			Case TERRAIN3_COLOR
				SetColor 221,209,0
			EndSelect
		EndIf
		DrawRect x,base[x],1,(config_height-base[x])
	Next
EndFunction
